Subject: Re: [sfc] WGLC for https://datatracker.ietf.org/doc/draft-ietf-sfc-ioam-nsh/

From: James Guichard <[email-masked]>
Date: Tue, 1 Feb 2022 10:59:19 +0000

Hi Shwetha & Greg,

Thank you for the update.

I still believe however that more work is necessary to reconcile how SFC OAM is supposed to work. RFC 8300 says:

   O bit:  Setting this bit indicates an OAM packet (see [RFC6291<https://datatracker.ietf.org/doc/html/rfc6291>]).
      The actual format and processing of SFC OAM packets is outside the
      scope of this specification (for example, see [SFC-OAM-FRAMEWORK<https://datatracker.ietf.org/doc/html/rfc8300#ref-SFC-OAM-FRAMEWORK>]
      for one approach).

      The O bit MUST be set for OAM packets and MUST NOT be set for
      non-OAM packets.

If we look at RFC6291 it simply describes what OAM is supposed to mean and this is independent from SFC. The SFC-OAM-Framework (now RFC 8924) in section 6.3 says:

   The Next Protocol field in the NSH header may be used to indicate what OAM function is intended
   or what toolset is used.  Any other overlay encapsulations used at the service layer must have a
   similar way to indicate the intended OAM function.

So my reading of this is that if you take 8300 together with the framework then 1. The O-bit MUST be set for OAM packets, and 2. The Next Protocol field may or may not be used to indicate which OAM function is to be applied. >From this I can determine that iOAM has taken the approach of using the next protocol field to indicate how to process the OAM packet and does NOT use the NSH context headers in any way shape or form. This seems consistent with the current definitions of the O-bit from RFC 8300 and processing guidelines from RFC 8924.

However, your document says:

4.1<https://datatracker.ietf.org/doc/html/draft-ietf-sfc-ioam-nsh-07#section-4.1>.  IOAM and the use of the NSH O-bit

   [RFC8300] defines an "O bit" for OAM packets.  Per [RFC8300<https://datatracker.ietf.org/doc/html/rfc8300>] the O
   bit must be set for OAM packets and must not be set for non-OAM
   packets.  Packets with IOAM data included MUST follow this
   definition, i.e. the O bit MUST NOT be set for regular customer
   traffic which also carries IOAM data and the O bit MUST be set for
   OAM packets which carry only IOAM data without any regular data
   payload.

This text basically says that if the packet is customer traffic and happens to carry iOAM data then it is NOT an OAM packet.  What am I missing, customer traffic or not, both carry iOAM data so how are they different within an SFC domain?

In addition to the above I will note that there is still a conflict with Greg's draft namely this text from section 4:

   *  O bit set and the "Next Protocol" value does not match the value
      Active SFC OAM (TBA1), defined in Section 10.1<https://datatracker.ietf.org/doc/html/draft-ietf-sfc-multi-layer-oam#section-10.1>:

         - An SFC NSH Context Header(s) contain an OAM processing
         instructions or data.

         - The "Next Protocol" field determines the type of the payload.

The above text suggests to me that if the O-bit is set and the next protocol is not active SFC OAM then it is *required* that OAM data will be in the NSH context headers (which is not the case for iOAM) and the next protocol will indicate what follows the NSH header. While iOAM does follow the NSH header as indicated by the next protocol there is still an expectation that OAM is also carried in the NSH context headers. This seems to be in conflict with RFC 8300 AND RFC 8924.

This of course is just my reading of the text and I would like to hear yours and other folks thoughts.

Jim

From: Shwetha Bhandari <[email-masked]>
Sent: Monday, January 31, 2022 11:25 PM
To: Greg Mirsky <[email-masked]>
Cc: James Guichard <[email-masked]>; [email-masked]; [email-masked]; [email-masked]
Subject: Re: [sfc] WGLC for https://datatracker.ietf.org/doc/draft-ietf-sfc-ioam-nsh/

Hi Greg,

Sorry for the late action on this. https://datatracker.ietf.org/doc/html/draft-ietf-sfc-ioam-nsh-07<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Fdraft-ietf-sfc-ioam-nsh-07&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Caf9cde32be65486e459d08d9e53ac90c%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C1%7C637792862928234181%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=pl23JSzuzl5p2F8vooPyxVcUnWRdcWx%2F26MRFfJAIh4%3D&reserved=0> has been now posted with the edits per this discussion.

Hi Jim,

After Greg's review please let us know if the changes are good to progress the draft to the next step.

Thanks,
Shwetha

On Wed, Oct 27, 2021 at 7:31 PM Greg Mirsky <[email-masked]<mailto:[email-masked]>> wrote:
Hi Shwetha,
thank you for the detailed response to my comments. Please feel free to share any updates you're considering for the next version. I'll be glad to work together on these.
I have several follow-up notes in-lined below under the GIM>> tag.

Regards,
Greg

On Tue, Oct 26, 2021 at 6:51 PM Shwetha Bhandari <[email-masked]<mailto:[email-masked]>> wrote:
Hi Greg,

Sorry for the very late reply. Please find responses to your comments inline @Shwetha:

On Wed, Sep 8, 2021 at 3:30 AM Greg Mirsky <[email-masked]<mailto:[email-masked]>> wrote:
Dear Authors and All,
I've read the current version of the draft and have some comments I'd like to share with you. I much appreciate your thoughts on where this work should go considering developments in other IETF WGs. Please find my notes and questions below:

  *   It is stated in the Abstract that:
   In-situ Operations, Administration, and Maintenance (IOAM) records
   operational and telemetry information in the packet while the packet
   traverses a path between two points in the network.
But that is the case only for the pre-allocated and incremental trace option types. The Direct Export option<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fdraft-ietf-ippm-ioam-direct-export%2F__%3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKE0jphubQ%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Caf9cde32be65486e459d08d9e53ac90c%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C1%7C637792862928234181%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=i7sTr0MtC5qfzx3twOKSpbW8LkQJzsAJBxF%2FZPLUwKc%3D&reserved=0> does not write telemetry data into the data packet itself but export telemetry information in a specially constructed packet.
And as we are talking about different IOAM trace options, the question of the scope of this document seems appropriate. There is a WGLC on two IOAM documents<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fmailarchive.ietf.org%2Farch%2Fmsg%2Fippm%2FA0OcGQ5LlNjnjfRVp_iUTMYMrcs%2F__%3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKHOndSFRg%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Caf9cde32be65486e459d08d9e53ac90c%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C1%7C637792862928234181%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=cHtvsgDl%2FuzSv70oS9LN5l2o5nEIwiKHDZ1sfiFJCrE%3D&reserved=0> active through September 15th at the IPPM WG. I believe that it would be beneficial if we had a single document that describes the applicability of IOAM in all its functionality defined by documents in IPPM WG. Of course, that cannot be a moving target as that would not be helpful. But since the IPPM WG discusses the progress of two IOAM documents, it could be a great time to address the applicability of the Direct Export trace type<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fdraft-ietf-ippm-ioam-direct-export%2F__%3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKE0jphubQ%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Caf9cde32be65486e459d08d9e53ac90c%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C1%7C637792862928234181%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=i7sTr0MtC5qfzx3twOKSpbW8LkQJzsAJBxF%2FZPLUwKc%3D&reserved=0> and Loopback and Active flags defined in draft-ietf-ippm-ioam-flags<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fdraft-ietf-ippm-ioam-flags%2F__%3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKHO7lReVw%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Caf9cde32be65486e459d08d9e53ac90c%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C1%7C637792862928234181%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=1kqtcu3xjl1C7ytQ%2BoaKdiQN96rQt94e1S2ElC0nD3M%3D&reserved=0>. It would be concerning to have more than one SFC document describing the applicability of the generic IOAM mechanisms

Shwetha> This is a fair point. We will revise the  draft with text in the abstract and Section 3 IOAM-Type to be updated to include the usage of trace and DEX options.  The encapsulation of IOAM options within NSH itself in its current form already supports all the IOAM Option Type defined both from draft-ietf-ippm-ioam-data and draft-ietf-ippm-ioam-direct-export along with the flags supported within the options. Hence the IOAM-data-field definitions in the draft will remain unchanged.
GIM>> I agree that the definitions of the IOAM data-fields are invariant in various data plane encapsulations. You likely follow the discussion of the IAOM Direct Export and IOAM flags on the IPPM WG list. I think that for SFC NSH, IOAM Direct Export could be as simple as "use the local policy". The applicability of the Loopback and Active flags seems to require detailed explanation by SFP actors.

  *   The location of the IOAM header in the SFC NSH-encapsulated packet is defined in Section 3:
   IOAM-Data-Fields are carried in NSH
   using a next protocol header which follows the NSH MD context
   headers.
I've checked RFC 8300 but couldn't find it defines the Next Protocol header. Also, it appears that NSH Context headers are optional. Hence my question. Is the presence of an NSH Context header required when using IOAM? Could you clarify which mechanism is used to identify the payload of an SFC NSH-encapsulated packet as IOAM?
Shwetha> We will reword it, it is not Next Protocol header but using IOAM as a Next Protocol as described in Section 4.1 and requested in IANA section. Following is the proposed text to align with the RFC 8300 reference to context headers following base header and service path header:
"The NSH is defined in [RFC8300].  IOAM-Data-Fields are carried in NSH using a next protocol to identify IOAM data fields that follows NSH context headers."
GIM>> I think that RFC 8300 views data following Context Headers as NSH payload, not being "in NSH".

  *   If I understand the format of the IOAM header defined in Section 3 correctly, the header's length is limited by 1020 octets, while the effective length containing IOAM options and data - 1016 octets. Is that correct? What is the recommended technique of collecting IOAM data that exceeds that limit?
Shwetha > IOAM options inherently support specifying the size limits at the node that added the IOAM options. While operationalizing the solution the data types included and number of nodes expected to be adding the data should be selected. This is covered in deployment considerations draft-brockners-opsawg-ioam-deployment.

  *   In Section 4.1, I've found the text reflecting the history of the discussion about how to carry the IOAM header using NSH encapsulation. As the text has no normative value, I suggest moving it into an Appendix.
Shwetha > Agreed, revised draft will have this section moved to Appendix.
GIM>> Thank you.

  *   I find the rules of handling the O-bit in NSH listed in Section 4.2 inconsistent and confusing. The IOAM header is not part of NSH encapsulation but is a part of the payload. But in one case, when user data follows it, the O-bit must not be set as. If there's no user data after the IOAM header, then the O-bit must be set. But from the perspective of NSH encapsulation, it includes specially constructed data added for the sole purpose of collecting OAM/telemetry information. Then, why, in one case, the O-bit is cleared and in the other set if, in both cases, the NSH-encapsulated packet is used to perform the OAM function?
Shwetha > The reason for not setting the O-bit for packets that contains actual user data is because RFC 8300 has " SF/SFF/SFC Proxy/Classifier implementations that do not support

      SFC OAM procedures SHOULD discard packets with O bit set". It will be undesirable to discard packets with O-bit set that carry user data as IOAM can be inserted insitu.

For synthetic traffic created for OAM along with IOAM-data-fields in NSH following the NSH OAM function with 0-bit set is desirable.
 GIM>> This is an interesting situation. I agree that there could be an SFC element not supporting "SFC OAM procedures" (not clear what these are). By the same token, would such SFC element support IOAM, be capable of processing IOAM without adverse impact to user data? I am not certain and it seems that it might be better to recommend that NSH packets with IOAM be dropped by an SFP element if it does not support "SFC OAM". What are your thoughts?

Thanks,
Shwetha
I much appreciate your consideration of my comments and questions and looking forward to your feedback.

Regards,
Greg

On Wed, Aug 18, 2021 at 5:32 AM James Guichard <[email-masked]<mailto:[email-masked]>> wrote:
Dear WG:

This email starts a 2 week Working Group Last Call for draft-ietf-sfc-ioam-nsh [1].

Please read this document if you haven't read the most recent version and send your comments to the SFC WG list no later than September 1st 2021.

If you are raising a point which you expect will be specifically debated on the mailing list, consider using a specific email/thread for this point.

Lastly, if you are an author or contributor please response to indicate whether you know of any undisclosed IPR related to this document.

Thanks!

Jim & Joel

[1] https://datatracker.ietf.org/doc/draft-ietf-sfc-ioam-nsh/<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fdraft-ietf-sfc-ioam-nsh%2F__%3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKHdTiRE6A%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Caf9cde32be65486e459d08d9e53ac90c%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C1%7C637792862928234181%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=9uDdhw0ViwBtWvn52V8UZ2G77lRnSye2Ols5z3U8QwQ%3D&reserved=0>

_______________________________________________
sfc mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/sfc<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fsfc__%3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKEKMsIVaA%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Caf9cde32be65486e459d08d9e53ac90c%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C1%7C637792862928234181%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=Lrdp7ipXNWqDvp3mWkIQWF%2FJoClfmd4G3TlaH2kB550%3D&reserved=0>

---

From: Greg Mirsky <[email-masked]>
Date: Tue, 1 Feb 2022 13:56:58 -0800

Hi Shwetha,
thank you for your kind consideration of my comments and questions, and the
work you put into addressing them; much appreciated.
I find many of my comments and questions resolved. There are a few
remaining and I hope you will clarify them to me. Please find my follow-up
notes below:

   - I couldn't find how an IOAM header with Active or Loopback flags
   <https://datatracker.ietf.org/doc/draft-ietf-ippm-ioam-flags/> set must
   be handled by an SFF.
   - The closing of Section 4.1 can be interpreted as IOAM can be the only
   payload immediately following the NSH:

... the O bit MUST be set for

   payload

Would in this situation the Active flag must be set in the IOAM header? And
if no "regular data payload" is present, wouldn't IOAM become not a hybrid
measurement method, as it is characterized in draft-ietf-ippm-ioam-data,
but, according to RFC 7799, an active OAM?

Kind regards,
Greg

On Mon, Jan 31, 2022 at 8:24 PM Shwetha Bhandari <
[email-masked]> wrote:

> Hi Greg,
>
> Sorry for the late action on this.
> https://datatracker.ietf.org/doc/html/draft-ietf-sfc-ioam-nsh-07 has been
> now posted with the edits per this discussion.
>
> Hi Jim,
>
> On Wed, Oct 27, 2021 at 7:31 PM Greg Mirsky <[email-masked]> wrote:
>
>> Hi Shwetha,
>> thank you for the detailed response to my comments. Please feel free to
>> share any updates you're considering for the next version. I'll be glad to
>> work together on these.
>> On Tue, Oct 26, 2021 at 6:51 PM Shwetha Bhandari <
>> [email-masked]> wrote:
>>
>>> Hi Greg,
>>>
>>> On Wed, Sep 8, 2021 at 3:30 AM Greg Mirsky <[email-masked]>
>>> wrote:
>>>
>>>> Dear Authors and All,
>>>> I've read the current version of the draft and have some comments I'd
>>>> like to share with you. I much appreciate your thoughts on where this work
>>>> should go considering developments in other IETF WGs. Please find my notes
>>>> and questions below:
>>>>
>>>>    - It is stated in the Abstract that:
>>>>
>>>> But that is the case only for the pre-allocated and incremental trace
>>>> option types. The Direct Export option
>>>> <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/draft-ietf-ippm-ioam-direct-export/__;!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKE0jphubQ$>
>>>> does not write telemetry data into the data packet itself but export
>>>> telemetry information in a specially constructed packet.
>>>> And as we are talking about different IOAM trace options, the
>>>> question of the scope of this document seems appropriate. There is a
>>>> WGLC on two IOAM documents
>>>> <https://urldefense.com/v3/__https://mailarchive.ietf.org/arch/msg/ippm/A0OcGQ5LlNjnjfRVp_iUTMYMrcs/__;!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKHOndSFRg$>
>>>> active through September 15th at the IPPM WG. I believe that it would be
>>>> beneficial if we had a single document that describes the applicability of
>>>> IOAM in all its functionality defined by documents in IPPM WG. Of course,
>>>> that cannot be a moving target as that would not be helpful. But since the
>>>> IPPM WG discusses the progress of two IOAM documents, it could be a great
>>>> time to address the applicability of the Direct Export trace type
>>>> <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/draft-ietf-ippm-ioam-direct-export/__;!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKE0jphubQ$>
>>>> and Loopback and Active flags defined in draft-ietf-ippm-ioam-flags
>>>> <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/draft-ietf-ippm-ioam-flags/__;!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKHO7lReVw$>.
>>>> It would be concerning to have more than one SFC document describing the
>>>> applicability of the generic IOAM mechanisms
>>>>
>>>>
>>> Shwetha> This is a fair point. We will revise the  draft with text in
>>> the abstract and Section 3 IOAM-Type to be updated to include the usage
>>> of trace and DEX options.  The encapsulation of IOAM options within NSH
>>> itself in its current form already supports all the IOAM Option Type
>>> defined both from draft-ietf-ippm-ioam-data and
>>> draft-ietf-ippm-ioam-direct-export along with the flags supported
>>> within the options. Hence the IOAM-data-field definitions in the draft will
>>> remain unchanged.
>>>
>> GIM>> I agree that the definitions of the IOAM data-fields are invariant
>> in various data plane encapsulations. You likely follow the discussion of
>> the IAOM Direct Export and IOAM flags on the IPPM WG list. I think that for
>> SFC NSH, IOAM Direct Export could be as simple as "use the local policy".
>> The applicability of the Loopback and Active flags seems to require
>> detailed explanation by SFP actors.
>>
>>>
>>>
>>>>
>>>>
>>>>    - The location of the IOAM header in the SFC
>>>>    NSH-encapsulated packet is defined in Section 3:
>>>>
>>>> I've checked RFC 8300 but couldn't find it defines the Next Protocol
>>>> header. Also, it appears that NSH Context headers are optional. Hence my
>>>> question. Is the presence of an NSH Context header required when using
>>>> IOAM? Could you clarify which mechanism is used to identify the payload of
>>>> an SFC NSH-encapsulated packet as IOAM?
>>>>
>>>> Shwetha> We will reword it, it is not Next Protocol header but using
>>> IOAM as a Next Protocol as described in Section 4.1 and requested in IANA
>>> section. Following is the proposed text to align with the RFC 8300
>>> reference to context headers following base header and service path header:
>>> "The NSH is defined in [RFC8300].  IOAM-Data-Fields are carried in
>>> NSH using a next protocol to identify IOAM data fields that follows NSH
>>> context headers."
>>>
>>>>    - If I understand the format of the IOAM header defined in Section
>>>>    3 correctly, the header's length is limited by 1020 octets, while the
>>>>    effective length containing IOAM options and data - 1016 octets. Is that
>>>>    correct? What is the recommended technique of collecting IOAM data that
>>>>    exceeds that limit?
>>>>
>>>> Shwetha > IOAM options inherently support specifying the size limits at
>>> the node that added the IOAM options. While operationalizing the solution
>>> the data types included and number of nodes expected to be adding the data
>>> should be selected. This is covered in deployment
>>> considerations draft-brockners-opsawg-ioam-deployment.
>>>
>>>>
>>>>    - In Section 4.1, I've found the text reflecting the history of the
>>>>    discussion about how to carry the IOAM header using NSH encapsulation. As
>>>>    the text has no normative value, I suggest moving it into an Appendix.
>>>>
>>>>    - I find the rules of handling the O-bit in NSH listed in Section
>>>>    4.2 inconsistent and confusing. The IOAM header is not part of NSH
>>>>    encapsulation but is a part of the payload. But in one case, when user data
>>>>    follows it, the O-bit must not be set as. If there's no user data after the
>>>>    IOAM header, then the O-bit must be set. But from the perspective of NSH
>>>>    encapsulation, it includes specially constructed data added for the sole
>>>>    purpose of collecting OAM/telemetry information. Then, why, in one case,
>>>>    the O-bit is cleared and in the other set if, in both cases, the
>>>>    NSH-encapsulated packet is used to perform the OAM function?
>>>>
>>>> Shwetha > The reason for not setting the O-bit for packets that
>>> contains actual user data is because RFC 8300 has " SF/SFF/SFC
>>> Proxy/Classifier implementations that do not support
>>>
>>>  GIM>> This is an interesting situation. I agree that there could be an
>> SFC element not supporting "SFC OAM procedures" (not clear what these are).
>> By the same token, would such SFC element support IOAM, be capable of
>> processing IOAM without adverse impact to user data? I am not certain and
>> it seems that it might be better to recommend that NSH packets with IOAM be
>> dropped by an SFP element if it does not support "SFC OAM". What are your
>> thoughts?
>>
>>
>>>
>>> Thanks,
>>> Shwetha
>>>
>>>> On Wed, Aug 18, 2021 at 5:32 AM James Guichard <
>>>> [email-masked]> wrote:
>>>>
>>>>> Dear WG:
>>>>>
>>>>>
>>>>>
>>>>> Please read this document if you haven’t read the most recent version
>>>>> and send your comments to the SFC WG list no later than September 1st
>>>>> 2021.
>>>>>
>>>>>
>>>>>
>>>>> If you are raising a point which you expect will be specifically
>>>>> debated on the mailing list, consider using a specific email/thread for
>>>>> this point.
>>>>>
>>>>>
>>>>>
>>>>> Lastly, if you are an author or contributor please response to
>>>>> indicate whether you know of any undisclosed IPR related to this document.
>>>>>
>>>>>
>>>>>
>>>>> Thanks!
>>>>>
>>>>>
>>>>>
>>>>> Jim & Joel
>>>>>
>>>>>
>>>>>
>>>>> [1] https://datatracker.ietf.org/doc/draft-ietf-sfc-ioam-nsh/
>>>>> <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/draft-ietf-sfc-ioam-nsh/__;!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKHdTiRE6A$>
>>>>>
>>>>>
>>>>>
>>>>>
>>>>>
>>>>>
>>>>> [email-masked]
>>>>> https://www.ietf.org/mailman/listinfo/sfc
>>>>> <https://urldefense.com/v3/__https://www.ietf.org/mailman/listinfo/sfc__;!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKEKMsIVaA$>
>>>>>
>>>>

---

From: Shwetha Bhandari <[email-masked]>
Date: Wed, 2 Feb 2022 20:59:04 +0530

Hi Jim, Greg,

Thanks for the follow up.
1) On O-bit: I am a bit confused about the O-bit feedback. Are you
suggesting that it should not be a consideration for IOAM as it is handled
as a next protocol and not as NSH context headers?
What should a SFC element handle a packet containing IOAM as next header
and does not implement IOAM and hence does not understand IOAM? I think
O-bit helps in such situations to help such elements decide to drop or
forward without processing the IOAM header.
Let me know if that is not the case and if simply not considering O-bit in
the context of IOAM is what you would recommend.
2) Active or Loopback flags
<https://urldefense.com/v3/__https://datatracker.ietf.org/doc/draft-ietf-ippm-ioam-flags/__;!!MZ3Fw45to5uY!eu05ObEvXtnVX2OXFzl0g16vk36xSqTyjMReG_i6BavtG_ru2AnjQSjXHiZ_Ve3sBjJRuHMBUg$>
-
there is nothing specific for NSH on how the flags are to be handled.  The
IOAM specific fields are to be handled as recommended by the respective
IOAM drafts. Do you see any specific NSH considerations to be documented
for IOAM fields?

Thanks,
Shwetha

On Tue, Feb 1, 2022 at 4:29 PM James Guichard <
[email-masked]> wrote:

>    O bit:  Setting this bit indicates an OAM packet (see [RFC6291
> <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/html/rfc6291__;!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJs06rKUNw$>
> ]).
>
>       scope of this specification (for example, see [SFC-OAM-FRAMEWORK
> <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/html/rfc8300*ref-SFC-OAM-FRAMEWORK__;Iw!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJsisioAug$>
> ]
>
>       for one approach).
>
>
>
> If we look at RFC6291 it simply describes what OAM is supposed to mean and
> this is independent from SFC. The SFC-OAM-Framework (now RFC 8924) in
> section 6.3 says:
>
>
>
> So my reading of this is that if you take 8300 together with the framework
> then 1. The O-bit MUST be set for OAM packets, and 2. The Next Protocol
> field may or may not be used to indicate which OAM function is to be
> applied. From this I can determine that iOAM has taken the approach of
> using the next protocol field to indicate how to process the OAM packet and
> does NOT use the NSH context headers in any way shape or form. This seems
> consistent with the current definitions of the O-bit from RFC 8300 and
> processing guidelines from RFC 8924.
>
>
>
> *4.1
> <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/html/draft-ietf-sfc-ioam-nsh-07*section-4.1__;Iw!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJtXMLMQUw$>.
> IOAM and the use of the NSH O-bit*
>
>
>
>    [RFC8300] defines an "O bit" for OAM packets.  Per [RFC8300
> <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/html/rfc8300__;!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJuMIrqXAQ$>]
> the O
>
> This text basically says that if the packet is customer traffic and
> happens to carry iOAM data then it is NOT an OAM packet.  What am I
> missing, customer traffic or not, both carry iOAM data so how are they
> different within an SFC domain?
>
>
>
> In addition to the above I will note that there is still a conflict with
> Greg’s draft namely this text from section 4:
>
>       Active SFC OAM (TBA1), defined in Section 10.1
> <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/html/draft-ietf-sfc-multi-layer-oam*section-10.1__;Iw!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJv1ohYIeg$>
> :
>
>
>
> The above text suggests to me that if the O-bit is set and the next
> protocol is not active SFC OAM then it is **required** that OAM data will
> be in the NSH context headers (which is not the case for iOAM) and the next
> protocol will indicate what follows the NSH header. While iOAM does follow
> the NSH header as indicated by the next protocol there is still an
> expectation that OAM is also carried in the NSH context headers. This seems
> to be in conflict with RFC 8300 AND RFC 8924.
>
>
>
> *From:* Shwetha Bhandari <[email-masked]>
> *Sent:* Monday, January 31, 2022 11:25 PM
> *To:* Greg Mirsky <[email-masked]>
> *Cc:* James Guichard <[email-masked]>;
> [email-masked]; [email-masked]; [email-masked]
> *Subject:* Re: [sfc] WGLC for
> https://datatracker.ietf.org/doc/draft-ietf-sfc-ioam-nsh/
> <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/draft-ietf-sfc-ioam-nsh/__;!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJu3416GCQ$>
>
>
>
> Hi Greg,
>
>
>
> https://datatracker.ietf.org/doc/html/draft-ietf-sfc-ioam-nsh-07
> <https://urldefense.com/v3/__https://nam11.safelinks.protection.outlook.com/?url=https*3A*2F*2Fdatatracker.ietf.org*2Fdoc*2Fhtml*2Fdraft-ietf-sfc-ioam-nsh-07&data=04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000&sdata=pl23JSzuzl5p2F8vooPyxVcUnWRdcWx*2F26MRFfJAIh4*3D&reserved=0__;JSUlJSUlJSUlJSUlJSUlJSUlJSU!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJvEbkwM5w$>
> has been now posted with the edits per this discussion.
>
>
>
> Hi Jim,
>
>
>
> On Wed, Sep 8, 2021 at 3:30 AM Greg Mirsky <[email-masked]> wrote:
>
> Dear Authors and All,
>
> I've read the current version of the draft and have some comments I'd like
> to share with you. I much appreciate your thoughts on where this work
> <https://urldefense.com/v3/__https://nam11.safelinks.protection.outlook.com/?url=https*3A*2F*2Furldefense.com*2Fv3*2F__https*3A*2F*2Fdatatracker.ietf.org*2Fdoc*2Fdraft-ietf-ippm-ioam-direct-export*2F__*3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKE0jphubQ*24&data=04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000&sdata=i7sTr0MtC5qfzx3twOKSpbW8LkQJzsAJBxF*2FZPLUwKc*3D&reserved=0__;JSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUl!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJt0mRguJg$>
> And as we are talking about different IOAM trace options, the question of
> the scope of this document seems appropriate. There is a WGLC on two IOAM
> documents
> <https://urldefense.com/v3/__https://nam11.safelinks.protection.outlook.com/?url=https*3A*2F*2Furldefense.com*2Fv3*2F__https*3A*2F*2Fmailarchive.ietf.org*2Farch*2Fmsg*2Fippm*2FA0OcGQ5LlNjnjfRVp_iUTMYMrcs*2F__*3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKHOndSFRg*24&data=04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000&sdata=cHtvsgDl*2FuzSv70oS9LN5l2o5nEIwiKHDZ1sfiFJCrE*3D&reserved=0__;JSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSU!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJu2SsX7cg$>
> <https://urldefense.com/v3/__https://nam11.safelinks.protection.outlook.com/?url=https*3A*2F*2Furldefense.com*2Fv3*2F__https*3A*2F*2Fdatatracker.ietf.org*2Fdoc*2Fdraft-ietf-ippm-ioam-direct-export*2F__*3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKE0jphubQ*24&data=04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000&sdata=i7sTr0MtC5qfzx3twOKSpbW8LkQJzsAJBxF*2FZPLUwKc*3D&reserved=0__;JSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUl!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJt0mRguJg$>
> <https://urldefense.com/v3/__https://nam11.safelinks.protection.outlook.com/?url=https*3A*2F*2Furldefense.com*2Fv3*2F__https*3A*2F*2Fdatatracker.ietf.org*2Fdoc*2Fdraft-ietf-ippm-ioam-flags*2F__*3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKHO7lReVw*24&data=04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000&sdata=1kqtcu3xjl1C7ytQ*2BoaKdiQN96rQt94e1S2ElC0nD3M*3D&reserved=0__;JSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUl!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJt8NqRRKg$>.
> Shwetha> This is a fair point. We will revise the  draft with text in the
> abstract and Section 3 IOAM-Type to be updated to include the usage of
> trace and DEX options.  The encapsulation of IOAM options within NSH itself
> in its current form already supports all the IOAM Option Type defined both
> from draft-ietf-ippm-ioam-data and draft-ietf-ippm-ioam-direct-export
> along with the flags supported within the options. Hence the
> IOAM-data-field definitions in the draft will remain unchanged.
>
>    - The location of the IOAM header in the SFC NSH-encapsulated packet
>    is defined in Section 3:
>
> Shwetha> We will reword it, it is not Next Protocol header but using IOAM
> as a Next Protocol as described in Section 4.1 and requested in IANA
>    - If I understand the format of the IOAM header defined in Section 3
>    correctly, the header's length is limited by 1020 octets, while the
>    - I find the rules of handling the O-bit in NSH listed in Section 4.2
>    inconsistent and confusing. The IOAM header is not part of NSH
> Shwetha > The reason for not setting the O-bit for packets that contains
> actual user data is because RFC 8300 has " SF/SFF/SFC Proxy/Classifier
> implementations that do not support
>
> Please read this document if you haven’t read the most recent version and
> send your comments to the SFC WG list no later than September 1st 2021.
>
>
>
> If you are raising a point which you expect will be specifically debated
> on the mailing list, consider using a specific email/thread for this point.
>
>
>
> Lastly, if you are an author or contributor please response to indicate
> whether you know of any undisclosed IPR related to this document.
>
>
>
> Thanks!
>
>
>
> Jim & Joel
>
>
>
> <https://urldefense.com/v3/__https://nam11.safelinks.protection.outlook.com/?url=https*3A*2F*2Furldefense.com*2Fv3*2F__https*3A*2F*2Fdatatracker.ietf.org*2Fdoc*2Fdraft-ietf-sfc-ioam-nsh*2F__*3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKHdTiRE6A*24&data=04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000&sdata=9uDdhw0ViwBtWvn52V8UZ2G77lRnSye2Ols5z3U8QwQ*3D&reserved=0__;JSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSU!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJv33kGkLw$>
>
>
>
>
>
>
>
> <https://urldefense.com/v3/__https://nam11.safelinks.protection.outlook.com/?url=https*3A*2F*2Furldefense.com*2Fv3*2F__https*3A*2F*2Fwww.ietf.org*2Fmailman*2Flistinfo*2Fsfc__*3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKEKMsIVaA*24&data=04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000&sdata=Lrdp7ipXNWqDvp3mWkIQWF*2FJoClfmd4G3TlaH2kB550*3D&reserved=0__;JSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUl!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJv0WsQtHA$>
>
>

---

From: Greg Mirsky <[email-masked]>
Date: Wed, 2 Feb 2022 08:28:34 -0800

Hi Shwetha,
thank you for your questions. Please find my notes in-line below under the
GIM>> tag.

Regards,
Greg

> forward without processing the IOAM header.
GIM>> I cannot find the text in the draft suggesting that an SFF that does
not support IOAM may forward the packet with the NSH Next Protocol field
equal to IOAM protocol identifier. Could you help me find it?

> <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/draft-ietf-ippm-ioam-flags/__;!!MZ3Fw45to5uY!eu05ObEvXtnVX2OXFzl0g16vk36xSqTyjMReG_i6BavtG_ru2AnjQSjXHiZ_Ve3sBjJRuHMBUg$> -
GIM>> For example, if the Loopback IOAM flag is set, the node is required
to send a copy of the packet back to the IOAM encapsulating node. It is not
clear to me how an SFF learns the identity of the IOAM encapsulating node
and how it encapsulates the loopbacked packet. Can you help me find how it
is supposed to work in the NSH?

>> If we look at RFC6291 it simply describes what OAM is supposed to mean
>> and this is independent from SFC. The SFC-OAM-Framework (now RFC 8924) in
>> section 6.3 says:
>>
>>
>>
>> So my reading of this is that if you take 8300 together with the
>> framework then 1. The O-bit MUST be set for OAM packets, and 2. The Next
>> Protocol field may or may not be used to indicate which OAM function is to
>> be applied. From this I can determine that iOAM has taken the approach of
>> protocol is not active SFC OAM then it is **required** that OAM data
>> will be in the NSH context headers (which is not the case for iOAM) and the
>> next protocol will indicate what follows the NSH header. While iOAM does
>> follow the NSH header as indicated by the next protocol there is still an
>> the scope of this document seems appropriate. There is a WGLC on two
>> IOAM documents

---

From: Greg Mirsky <[email-masked]>
Date: Wed, 2 Feb 2022 17:18:16 -0800

Hi Shwetha,
I have one more question. As the draft now mentions the option of using
IOAM Direct Export to collect the IOAM data, it might be helpful reflecting
that in the figure on p.2. I think that the caption "IOAM Option and Data
Space" might be reworded to "IOAM Option and Optional Data Space".
What are your thoughts?

Regards,
Greg

---

From: Shwetha Bhandari <[email-masked]>
Date: Wed, 9 Feb 2022 20:27:21 +0530

Hi Jim,

On the O bit handling, are you suggesting that the O-bit for IOAM, that is
carried as a next protocol following NSH header, is not applicable? Would
removing the section on O-bit considerations resolve your concern?

Hi Greg,

IOAM Direct Export to collect the IOAM data, it might be helpful reflecting
that in the figure on p.2. I think that the caption "IOAM Option and Data
Space" might be reworded to "IOAM Option and Optional Data Space".
What are your thoughts?
Yes, that will make it accurate. I will update the diagram and publish a
new version.

>I cannot find the text in the draft suggesting that an SFF that does not
support IOAM may forward the packet with the NSH Next Protocol field equal
to IOAM protocol identifier. Could you help me find it?
Can you suggest text to help with this ? This would be a generic problem
for NSH implementation when a next protocol is set to a value it does not
understand. What should is recommended action in this situation?

> For example, if the Loopback IOAM flag is set, the node is required to
send a copy of the packet back to the IOAM encapsulating node. It is not
clear to me how an SFF learns the identity of the IOAM encapsulating node
and how it encapsulates the loopbacked packet. Can you help me find how it
is supposed to work in the NSH?
https://datatracker.ietf.org/doc/html/draft-ietf-ippm-ioam-flags#section-4.2
:

  A Loopback flag that is set indicates to the transit nodes processing
   this option that they are to create a copy of the received packet and
   send the copy back to the source of the packet.

Given this is explained in the flag handling, do you see a need to define
it again in NSH? IMHO the explanation of flag handling is quite generic for
any packet based transport.
Please share your thoughts and text suggestions to improve the draft for
flag handling if it requires clarification.

Thanks,
Shwetha

On Thu, Feb 3, 2022 at 6:48 AM Greg Mirsky <[email-masked]> wrote:

>> Let me know if that is not the case and if simply not considering O-bit
>> in the context of IOAM is what you would recommend.
>>> defined both from draft-ietf-ippm-ioam-data and draft-ietf-ippm-ioam-direct-export

---

From: Greg Mirsky <[email-masked]>
Date: Wed, 9 Feb 2022 18:11:41 -0800

Hi Shwetha,
thank you for your kind consideration of my comments. Please find my
follow-up notes in-lined below under the GIM>> tag.

Regards,
Greg

GIM>> Thank you.

> understand. What should is recommended action in this situation?
GIM>> I think that dropping the packet and notifying the operator (under
the controlled threshold) is the safest way to handle the situation.

> flag handling if it requires clarification.
GIM>> The IPPM draft describes the basic Loopback behavior without
specifying for every possible network layer. For the case of NSH, I find
that the following text from Section 4 provides the guidance:
   Loopback can be used only if a return path from transit nodes and
   destination nodes towards the source (encapsulating node) exists.
   Specifically, loopback is only applicable in encapsulations in which
   the identity of the encapsulating node is available in the
   encapsulation header.  If an encapsulating node receives a looped
   back packet that was not originated from the current encapsulating
   node, the packet is dropped.
As the identity of the IOAM encapsulating node, to the best of my
understanding, is not available in NSH, the Loopback must not be used and
if the flag is set, the packet must be dropped. What do you think?
And continuing the discussion about that draft, I may propose a text on the
applicability of the IOAM Active flag:

The applicability of the IOAM Active [I-D.ietf-ippm-ioam-flags] is outside
the scope of this document and may be specified in the future.

>>>> I still believe however that more work is necessary to reconcile how
>>>> SFC OAM is supposed to work. RFC 8300 says:
>>>>
>>>>
>>>>
>>>> In addition to the above I will note that there is still a conflict
>>>> with Greg’s draft namely this text from section 4:
>>>>
>>>> the abstract and Section 3 IOAM-Type to be updated to include the
>>>> usage of trace and DEX options.  The encapsulation of IOAM options within
>>>> NSH itself in its current form already supports all the IOAM Option Type
>>>> GIM>> I agree that the definitions of the IOAM data-fields are
>>>> invariant in various data plane encapsulations. You likely follow the
>>>> discussion of the IAOM Direct Export and IOAM flags on the IPPM WG list. I
>>>> think that for SFC NSH, IOAM Direct Export could be as simple as "use the
>>>> local policy". The applicability of the Loopback and Active flags seems to
>>>> require detailed explanation by SFP actors.
>>>>
>>>>
>>>>
>>>>
>>>>
>>>>

---

From: James Guichard <[email-masked]>
Date: Thu, 10 Feb 2022 17:57:13 +0000

Hi Shwetha,

My only point was that in the case of IOAM the O-bit seems to be obsolete as you use the next protocol field rather than the context headers. It seems to me that the definition of the O-bit should be that if set then the context headers are used to obtain the OAM instructions. Currently that is not what 8300 says. As I said in my previous emails I would really like to hear the WGs opinion on what to do with the O-bit and we certainly need to reconcile the various documents to be following the same standard.

Jim

Sent: Wednesday, February 9, 2022 9:57 AM

Hi Jim,

On the O bit handling, are you suggesting that the O-bit for IOAM, that is carried as a next protocol following NSH header, is not applicable? Would removing the section on O-bit considerations resolve your concern?

Hi Greg,

>I have one more question. As the draft now mentions the option of using IOAM Direct Export to collect the IOAM data, it might be helpful reflecting that in the figure on p.2. I think that the caption "IOAM Option and Data Space" might be reworded to "IOAM Option and Optional Data Space".
What are your thoughts?
Yes, that will make it accurate. I will update the diagram and publish a new version.

>I cannot find the text in the draft suggesting that an SFF that does not support IOAM may forward the packet with the NSH Next Protocol field equal to IOAM protocol identifier. Could you help me find it?
Can you suggest text to help with this ? This would be a generic problem for NSH implementation when a next protocol is set to a value it does not understand. What should is recommended action in this situation?

> For example, if the Loopback IOAM flag is set, the node is required to send a copy of the packet back to the IOAM encapsulating node. It is not clear to me how an SFF learns the identity of the IOAM encapsulating node and how it encapsulates the loopbacked packet. Can you help me find how it is supposed to work in the NSH?
https://datatracker.ietf.org/doc/html/draft-ietf-ippm-ioam-flags#section-4.2<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Fdraft-ietf-ippm-ioam-flags%23section-4.2&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631120774%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=zcOpC0Gzzi8xzhttBqWaeaU3pMd0KDo%2FZYdGsEPG0uE%3D&reserved=0>:

   send the copy back to the source of the packet.
Given this is explained in the flag handling, do you see a need to define it again in NSH? IMHO the explanation of flag handling is quite generic for any packet based transport.
Please share your thoughts and text suggestions to improve the draft for flag handling if it requires clarification.

Thanks,
Shwetha

On Thu, Feb 3, 2022 at 6:48 AM Greg Mirsky <[email-masked]<mailto:[email-masked]>> wrote:
Hi Shwetha,
I have one more question. As the draft now mentions the option of using IOAM Direct Export to collect the IOAM data, it might be helpful reflecting that in the figure on p.2. I think that the caption "IOAM Option and Data Space" might be reworded to "IOAM Option and Optional Data Space".
What are your thoughts?

Regards,
Greg

On Wed, Feb 2, 2022 at 7:29 AM Shwetha Bhandari <[email-masked]<mailto:[email-masked]>> wrote:
Hi Jim, Greg,

Thanks for the follow up.
1) On O-bit: I am a bit confused about the O-bit feedback. Are you suggesting that it should not be a consideration for IOAM as it is handled as a next protocol and not as NSH context headers?
What should a SFC element handle a packet containing IOAM as next header and does not implement IOAM and hence does not understand IOAM? I think O-bit helps in such situations to help such elements decide to drop or forward without processing the IOAM header.
Let me know if that is not the case and if simply not considering O-bit in the context of IOAM is what you would recommend.
2) Active or Loopback flags<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fdraft-ietf-ippm-ioam-flags%2F__%3B!!MZ3Fw45to5uY!eu05ObEvXtnVX2OXFzl0g16vk36xSqTyjMReG_i6BavtG_ru2AnjQSjXHiZ_Ve3sBjJRuHMBUg%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=DvpZHlkn0PNCP5%2BzFQzGayutZGPUMxJXtPll6nR8Ay8%3D&reserved=0> - there is nothing specific for NSH on how the flags are to be handled.  The IOAM specific fields are to be handled as recommended by the respective IOAM drafts. Do you see any specific NSH considerations to be documented for IOAM fields?

Thanks,
Shwetha

On Tue, Feb 1, 2022 at 4:29 PM James Guichard <[email-masked]<mailto:[email-masked]>> wrote:
Hi Shwetha & Greg,

   O bit:  Setting this bit indicates an OAM packet (see [RFC6291<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Frfc6291__%3B!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJs06rKUNw%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=4wRcNgj93har9TlylAfX%2BtbW24VCqfneSZd0rD9CRzs%3D&reserved=0>]).
      The actual format and processing of SFC OAM packets is outside the
      scope of this specification (for example, see [SFC-OAM-FRAMEWORK<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Frfc8300*ref-SFC-OAM-FRAMEWORK__%3BIw!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJsisioAug%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=A6fkAO8CwRJeW5tLLEpU0GhZrqsBOm7nUiE1QiMxwVQ%3D&reserved=0>]
      for one approach).

4.1<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Fdraft-ietf-sfc-ioam-nsh-07*section-4.1__%3BIw!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJtXMLMQUw%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=w3hANsqqvVWz5oeH%2BLfPwS%2Fxwh2hNERJwCw5zwdrAMA%3D&reserved=0>.  IOAM and the use of the NSH O-bit

   [RFC8300] defines an "O bit" for OAM packets.  Per [RFC8300<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Frfc8300__%3B!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJuMIrqXAQ%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=a%2BVevL6noSzqRzdWg6dscjiqevlLbxcgEdTEmfJAY7U%3D&reserved=0>] the O

In addition to the above I will note that there is still a conflict with Greg's draft namely this text from section 4:
   *  O bit set and the "Next Protocol" value does not match the value
      Active SFC OAM (TBA1), defined in Section 10.1<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Fdraft-ietf-sfc-multi-layer-oam*section-10.1__%3BIw!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJv1ohYIeg%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=HTLx6e4sQCvsjXZKxG1GA8XPvdswsQKEMIEABitkprw%3D&reserved=0>:

Jim

From: Shwetha Bhandari <[email-masked]<mailto:[email-masked]>>
Sent: Monday, January 31, 2022 11:25 PM
To: Greg Mirsky <[email-masked]<mailto:[email-masked]>>
Cc: James Guichard <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: [sfc] WGLC for https://datatracker.ietf.org/doc/draft-ietf-sfc-ioam-nsh/<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fdraft-ietf-sfc-ioam-nsh%2F__%3B!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJu3416GCQ%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=NKz8%2Fm%2Fh7WXjK0OP8NF4j5cQ%2FYgSrSMULRmDt%2FkX%2B10%3D&reserved=0>

Hi Greg,

Sorry for the late action on this. https://datatracker.ietf.org/doc/html/draft-ietf-sfc-ioam-nsh-07<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fnam11.safelinks.protection.outlook.com%2F%3Furl%3Dhttps*3A*2F*2Fdatatracker.ietf.org*2Fdoc*2Fhtml*2Fdraft-ietf-sfc-ioam-nsh-07%26data%3D04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000%26sdata%3Dpl23JSzuzl5p2F8vooPyxVcUnWRdcWx*2F26MRFfJAIh4*3D%26reserved%3D0__%3BJSUlJSUlJSUlJSUlJSUlJSUlJSU!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJvEbkwM5w%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=dpoyXLu%2F9fGVSgLtewdI7wNfSPdrkhs7FtBdD3Aq7%2B0%3D&reserved=0> has been now posted with the edits per this discussion.

Hi Jim,

Thanks,
Shwetha

Regards,
Greg

  *   It is stated in the Abstract that:
   In-situ Operations, Administration, and Maintenance (IOAM) records
   operational and telemetry information in the packet while the packet
   traverses a path between two points in the network.
But that is the case only for the pre-allocated and incremental trace option types. The Direct Export option<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fnam11.safelinks.protection.outlook.com%2F%3Furl%3Dhttps*3A*2F*2Furldefense.com*2Fv3*2F__https*3A*2F*2Fdatatracker.ietf.org*2Fdoc*2Fdraft-ietf-ippm-ioam-direct-export*2F__*3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKE0jphubQ*24%26data%3D04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000%26sdata%3Di7sTr0MtC5qfzx3twOKSpbW8LkQJzsAJBxF*2FZPLUwKc*3D%26reserved%3D0__%3BJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUl!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJt0mRguJg%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=yVGpJY1y6dud5c44HOsptPjqEuXdNUa1DMzjAelvU5c%3D&reserved=0> does not write telemetry data into the data packet itself but export telemetry information in a specially constructed packet.
And as we are talking about different IOAM trace options, the question of the scope of this document seems appropriate. There is a WGLC on two IOAM documents<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fnam11.safelinks.protection.outlook.com%2F%3Furl%3Dhttps*3A*2F*2Furldefense.com*2Fv3*2F__https*3A*2F*2Fmailarchive.ietf.org*2Farch*2Fmsg*2Fippm*2FA0OcGQ5LlNjnjfRVp_iUTMYMrcs*2F__*3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKHOndSFRg*24%26data%3D04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000%26sdata%3DcHtvsgDl*2FuzSv70oS9LN5l2o5nEIwiKHDZ1sfiFJCrE*3D%26reserved%3D0__%3BJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSU!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJu2SsX7cg%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=Y%2BwywuTSj4SpugrjmDTquAY0MZWKoT43CMjsyha%2FnOc%3D&reserved=0> active through September 15th at the IPPM WG. I believe that it would be beneficial if we had a single document that describes the applicability of IOAM in all its functionality defined by documents in IPPM WG. Of course, that cannot be a moving target as that would not be helpful. But since the IPPM WG discusses the progress of two IOAM documents, it could be a great time to address the applicability of the Direct Export trace type<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fnam11.safelinks.protection.outlook.com%2F%3Furl%3Dhttps*3A*2F*2Furldefense.com*2Fv3*2F__https*3A*2F*2Fdatatracker.ietf.org*2Fdoc*2Fdraft-ietf-ippm-ioam-direct-export*2F__*3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKE0jphubQ*24%26data%3D04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000%26sdata%3Di7sTr0MtC5qfzx3twOKSpbW8LkQJzsAJBxF*2FZPLUwKc*3D%26reserved%3D0__%3BJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUl!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJt0mRguJg%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=yVGpJY1y6dud5c44HOsptPjqEuXdNUa1DMzjAelvU5c%3D&reserved=0> and Loopback and Active flags defined in draft-ietf-ippm-ioam-flags<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fnam11.safelinks.protection.outlook.com%2F%3Furl%3Dhttps*3A*2F*2Furldefense.com*2Fv3*2F__https*3A*2F*2Fdatatracker.ietf.org*2Fdoc*2Fdraft-ietf-ippm-ioam-flags*2F__*3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKHO7lReVw*24%26data%3D04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000%26sdata%3D1kqtcu3xjl1C7ytQ*2BoaKdiQN96rQt94e1S2ElC0nD3M*3D%26reserved%3D0__%3BJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUl!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJt8NqRRKg%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=zzcnXlewWKrtEDv4BmsNNk4pvDlMKNKvPzBZ2dZJm5k%3D&reserved=0>. It would be concerning to have more than one SFC document describing the applicability of the generic IOAM mechanisms

Thanks,
Shwetha

Regards,
Greg

Thanks!

Jim & Joel

[1] https://datatracker.ietf.org/doc/draft-ietf-sfc-ioam-nsh/<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fnam11.safelinks.protection.outlook.com%2F%3Furl%3Dhttps*3A*2F*2Furldefense.com*2Fv3*2F__https*3A*2F*2Fdatatracker.ietf.org*2Fdoc*2Fdraft-ietf-sfc-ioam-nsh*2F__*3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKHdTiRE6A*24%26data%3D04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000%26sdata%3D9uDdhw0ViwBtWvn52V8UZ2G77lRnSye2Ols5z3U8QwQ*3D%26reserved%3D0__%3BJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSU!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJv33kGkLw%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=S6sx7MrrVkzKepVgj45q%2F2KPZzBMyOFnol%2BMfgRQ730%3D&reserved=0>

_______________________________________________
sfc mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/sfc<https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Furldefense.com%2Fv3%2F__https%3A%2F%2Fnam11.safelinks.protection.outlook.com%2F%3Furl%3Dhttps*3A*2F*2Furldefense.com*2Fv3*2F__https*3A*2F*2Fwww.ietf.org*2Fmailman*2Flistinfo*2Fsfc__*3B!!MZ3Fw45to5uY!db6q3n8-5YqHkLtf3wyeBoUpO72v7UzeDtfPNhyePahNAYMo9eFdQxxBWM4C7Z0OJKEKMsIVaA*24%26data%3D04*7C01*7Cjames.n.guichard*40futurewei.com*7Caf9cde32be65486e459d08d9e53ac90c*7C0fee8ff2a3b240189c753a1d5591fedc*7C1*7C1*7C637792862928234181*7CUnknown*7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0*3D*7C3000%26sdata%3DLrdp7ipXNWqDvp3mWkIQWF*2FJoClfmd4G3TlaH2kB550*3D%26reserved%3D0__%3BJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUlJSUl!!MZ3Fw45to5uY!bzL7Vb_jHltGMCbCwne2rywfzpGjZW4o3fVr4clCr4Ir10KydDyJy5gHA8obfbMABJv0WsQtHA%24&data=04%7C01%7Cjames.n.guichard%40futurewei.com%7Ca5db82494c32402334fc08d9ebdc83cf%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637800154631277005%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&sdata=Xj4fU0JctSsPl6a36R%2Bp9N4RkQ%2Bs8m4V7s9Qm2HHIVw%3D&reserved=0>